/* Generated by GOB (v2.0.5)   (do not edit directly) */



/***************************************************************************
                          gtk-player.gob  -  GtkWidget That embeds mplayer
                             -------------------
    begin                : lun jan 6 02:08:47 BST 2002
    copyright            : (C) 2002 by Stphane Konstantaropoulos
    email                : ssk01@aber.ac.uk | stephanek@brutele.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * GtkPlayer:
 *
 * Class derived from LumPlayer that embeds mplayer.
 * We use a GtkSocket that receives the mplayer window through
 * The Xembed protocol (implemented by mplayer).
 * The runtime calls are made through a pipe to mplayer's stdin,
 * it is no guaranteed that they will be executed immediately.
 * There is no control on whether mplayer is still running or not.
 * It can use only mplayer's xvideo output, the X11 output gives
 * Bad X Parameters.
 * This widget has no other dependencies than Gtk (v 2 probably),
 * You can use any config that you want, just implement LumConfig class.
 *
 * Thanks to the mplayer team for their great piece of software!
 * Visit them at http://www.mplayerhq.hu
 *
 */


#include <glib.h>
#include <glib-object.h>
#ifndef __GTK_PLAYER_H__
#define __GTK_PLAYER_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <gtk/gtk.h>
#include <lum-player.h>


/*
 * Type checking and casting macros
 */
#define GTK_TYPE_PLAYER	(gtk_player_get_type())
#define GTK_PLAYER(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gtk_player_get_type(), GtkPlayer)
#define GTK_PLAYER_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gtk_player_get_type(), GtkPlayer const)
#define GTK_PLAYER_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gtk_player_get_type(), GtkPlayerClass)
#define GTK_IS_PLAYER(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gtk_player_get_type ())

#define GTK_PLAYER_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gtk_player_get_type(), GtkPlayerClass)

/* Private structure type */
typedef struct _GtkPlayerPrivate GtkPlayerPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GTK_PLAYER__
#define __TYPEDEF_GTK_PLAYER__
typedef struct _GtkPlayer GtkPlayer;
#endif
struct _GtkPlayer {
	LumPlayer __parent__;
	/*< private >*/
	GtkPlayerPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GtkPlayerClass GtkPlayerClass;
struct _GtkPlayerClass {
	LumPlayerClass __parent__;
};


/*
 * Public methods
 */
GType	gtk_player_get_type	(void);
GtkWidget * 	gtk_player_new	(LumConfig * config);
void 	gtk_player_set_contrast	(GtkPlayer * self,
					gint contrast);
void 	gtk_player_set_brightness	(GtkPlayer * self,
					gint brightness);
void 	gtk_player_set_hue	(GtkPlayer * self,
					gint hue);
void 	gtk_player_set_saturation	(GtkPlayer * self,
					gint saturation);
void 	gtk_player_toggle_runtime	(GtkPlayer * self);
void 	gtk_player_framedrop	(GtkPlayer * self,
					gboolean drop);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
