/* Generated by GOB (v2.0.5)   (do not edit directly) */



/***************************************************************************
                          gtk-xine.gob  -  Xine Gtk Widget
                             -------------------
    begin                : dim jan  26 02:08:47 BST 2002
    copyright            : (C) 2002 by Stphane Konstantaropoulos
    email                : ssk01@aber.ac.uk | stephanek@brutele.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * Code taken / inspired from gtk-xine.c from the totem project by Hadess
 * 
 * Thanks go to him for his nice implementation
 * 	Copyright (C) 2001-2002 the xine project
 * 	Heavily modified by Bastien Nocera <hadess@hadess.net>
 * 
 * My modifications:
 * Use gob for easier syntax, remove signals and a few properties,
 * remove fullscreen code. Implement fully LumPlayer.
 *
 * #TODO apply LumConfig fully. Remove unnecessary things.
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __GTK_XINE_H__
#define __GTK_XINE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <xine.h>
#include <gtk/gtk.h>
#include <lum-player.h>
typedef enum {
	GTX_STARTUP,
	GTX_NO_INPUT_PLUGIN,
	GTX_NO_DEMUXER_PLUGIN,
	GTX_DEMUXER_FAILED,
	GTX_NO_CODEC,
	GTX_MALFORMED_MRL,
} GtkXineError;

typedef enum {
	SPEED_PAUSE,
	SPEED_NORMAL,
} Speeds;

typedef struct
{
	gint type;		/* one of the signals in the following enum */
	GtkXineError error_type;
	char *message;		/* or NULL */
} GtkXineSignal;



/*
 * Type checking and casting macros
 */
#define GTK_TYPE_XINE	(gtk_xine_get_type())
#define GTK_XINE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gtk_xine_get_type(), GtkXine)
#define GTK_XINE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gtk_xine_get_type(), GtkXine const)
#define GTK_XINE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gtk_xine_get_type(), GtkXineClass)
#define GTK_IS_XINE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gtk_xine_get_type ())

#define GTK_XINE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gtk_xine_get_type(), GtkXineClass)

/* Private structure type */
typedef struct _GtkXinePrivate GtkXinePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GTK_XINE__
#define __TYPEDEF_GTK_XINE__
typedef struct _GtkXine GtkXine;
#endif
struct _GtkXine {
	LumPlayer __parent__;
	/*< private >*/
	GtkXinePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GtkXineClass GtkXineClass;
struct _GtkXineClass {
	LumPlayerClass __parent__;
	/*signal*/void (* error) (GtkXine * self, gchar * string, gint nr);
	/*signal*/void (* eos) (GtkXine * self);
	/*signal*/void (* title_change) (GtkXine * self, gchar * string);
	xine_t * xine;
};


/*
 * Public methods
 */
GType	gtk_xine_get_type	(void);
void 	gtk_xine_error	(GtkXine * self,
					gchar * string,
					gint nr);
void 	gtk_xine_eos	(GtkXine * self);
void 	gtk_xine_title_change	(GtkXine * self,
					gchar * string);
GtkWidget * 	gtk_xine_new	(LumConfig * config);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define gtk_xine_connect__error(object,func,data)	g_signal_connect(GTK_XINE(({GtkXine *___object = (object); ___object; })),"error",(GCallback)({void (* ___error) (GtkXine * self, gchar * string, gint nr, gpointer ___data ) = (func); ___error; }), (data))
#define gtk_xine_connect_after__error(object,func,data)	g_signal_connect_after(GTK_XINE(({GtkXine *___object = (object); ___object; })),"error",(GCallback)({void (* ___error) (GtkXine * self, gchar * string, gint nr, gpointer ___data ) = (func); ___error; }), (data))
#define gtk_xine_connect_data__error(object,func,data,destroy_data,flags)	g_signal_connect_data(GTK_XINE(({GtkXine *___object = (object); ___object; })),"error",(GCallback)({void (* ___error) (GtkXine * self, gchar * string, gint nr, gpointer ___data ) = (func); ___error; }), (data), (destroy_data), (GConnectFlags)(flags))
#define gtk_xine_connect__eos(object,func,data)	g_signal_connect(GTK_XINE(({GtkXine *___object = (object); ___object; })),"eos",(GCallback)({void (* ___eos) (GtkXine * self, gpointer ___data ) = (func); ___eos; }), (data))
#define gtk_xine_connect_after__eos(object,func,data)	g_signal_connect_after(GTK_XINE(({GtkXine *___object = (object); ___object; })),"eos",(GCallback)({void (* ___eos) (GtkXine * self, gpointer ___data ) = (func); ___eos; }), (data))
#define gtk_xine_connect_data__eos(object,func,data,destroy_data,flags)	g_signal_connect_data(GTK_XINE(({GtkXine *___object = (object); ___object; })),"eos",(GCallback)({void (* ___eos) (GtkXine * self, gpointer ___data ) = (func); ___eos; }), (data), (destroy_data), (GConnectFlags)(flags))
#define gtk_xine_connect__title_change(object,func,data)	g_signal_connect(GTK_XINE(({GtkXine *___object = (object); ___object; })),"title_change",(GCallback)({void (* ___title_change) (GtkXine * self, gchar * string, gpointer ___data ) = (func); ___title_change; }), (data))
#define gtk_xine_connect_after__title_change(object,func,data)	g_signal_connect_after(GTK_XINE(({GtkXine *___object = (object); ___object; })),"title_change",(GCallback)({void (* ___title_change) (GtkXine * self, gchar * string, gpointer ___data ) = (func); ___title_change; }), (data))
#define gtk_xine_connect_data__title_change(object,func,data,destroy_data,flags)	g_signal_connect_data(GTK_XINE(({GtkXine *___object = (object); ___object; })),"title_change",(GCallback)({void (* ___title_change) (GtkXine * self, gchar * string, gpointer ___data ) = (func); ___title_change; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define gtk_xine_connect__error(object,func,data)	g_signal_connect(GTK_XINE(object),"error",(GCallback)(func),(data))
#define gtk_xine_connect_after__error(object,func,data)	g_signal_connect_after(GTK_XINE(object),"error",(GCallback)(func),(data))
#define gtk_xine_connect_data__error(object,func,data,destroy_data,flags)	g_signal_connect_data(GTK_XINE(object),"error",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define gtk_xine_connect__eos(object,func,data)	g_signal_connect(GTK_XINE(object),"eos",(GCallback)(func),(data))
#define gtk_xine_connect_after__eos(object,func,data)	g_signal_connect_after(GTK_XINE(object),"eos",(GCallback)(func),(data))
#define gtk_xine_connect_data__eos(object,func,data,destroy_data,flags)	g_signal_connect_data(GTK_XINE(object),"eos",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define gtk_xine_connect__title_change(object,func,data)	g_signal_connect(GTK_XINE(object),"title_change",(GCallback)(func),(data))
#define gtk_xine_connect_after__title_change(object,func,data)	g_signal_connect_after(GTK_XINE(object),"title_change",(GCallback)(func),(data))
#define gtk_xine_connect_data__title_change(object,func,data,destroy_data,flags)	g_signal_connect_data(GTK_XINE(object),"title_change",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
